#ifndef __REGNOTIFYUTIL_H_
#define __REGNOTIFYUTIL_H_

/* Typedefs */
// eVC4 + PocketPC 2003SDKł͒`ĂȂ
DECLARE_HANDLE(HREGNOTIFY);

typedef enum tagREG_COMPARISONTYPE 
{ 
    REG_CT_ANYCHANGE,
    REG_CT_EQUAL,
    REG_CT_NOT_EQUAL,
    REG_CT_GREATER,
    REG_CT_GREATER_OR_EQUAL,
    REG_CT_LESS,
    REG_CT_LESS_OR_EQUAL,
    REG_CT_CONTAINS,
    REG_CT_STARTS_WITH,
    REG_CT_ENDS_WITH
} REG_COMPARISONTYPE;

typedef struct tagNOTIFICATIONCONDITION
{
    REG_COMPARISONTYPE ctComparisonType;
    DWORD dwMask;
    union
    {
        LPCTSTR psz;
        DWORD dw;
    } TargetValue;
} NOTIFICATIONCONDITION;


/* Functions */
BOOL
RNUtil_Initialize();

BOOL
RNUtil_Terminate();

HRESULT
RNUtil_RegistryNotifyWindow(
	HKEY					hKey,
	LPCTSTR					pszSubKey,
	LPCTSTR					pszValueName,
	HWND					hWnd,
	UINT					msg,
	DWORD					dwUserData,
	NOTIFICATIONCONDITION*	pCondition,
	HREGNOTIFY*				phNotify
);

HRESULT
RNUtil_RegistryCloseNotification(
	HREGNOTIFY	hNotify
);


HRESULT
RNUtil_RegistryGetDWORD(
	HKEY	hKey,
	LPCTSTR	pszSubKey,
	LPCTSTR	pszValueName,
	DWORD*	pdwData
);

#endif